DevExtreme v24.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Diagram - Node and Edge Arrays

This demo shows the JavaScript Diagram component's capability to load an external tree or a graph structure from two data sources: an array of shapes and an array of shape connectors. The connector is specified by the shape's ID attributes. The JavaScript Diagram transforms information from the data sources into a tree layout view.

Backend API
$(() => { $('#diagram').dxDiagram({ nodes: { dataSource: new DevExpress.data.ArrayStore({ key: 'id', data: flowNodes, }), textExpr: 'text', typeExpr: 'type', autoLayout: { type: 'layered', }, }, edges: { dataSource: new DevExpress.data.ArrayStore({ key: 'id', data: flowEdges, }), textExpr: 'text', fromExpr: 'fromId', toExpr: 'toId', }, toolbox: { groups: ['general'], }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <script src="https://cdn3.devexpress.com/jslib/24.1.6/js/dx-diagram.min.js"></script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.1.6/css/dx-diagram.min.css" /> <link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/24.1.6/css/dx.light.css" /> <script src="js/dx.all.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="data.js"></script> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="diagram"> </div> </div> </body> </html>
#diagram { height: 725px; }
const flowNodes = [ { id: 107, text: 'A new ticket', type: 'terminator', }, { id: 108, text: 'Analyze the issue', type: 'process', }, { id: 118, text: 'Do we have all information to work with?', type: 'diamond', }, { id: 120, text: 'Answered', type: 'terminator', }, { id: 121, text: 'Request additional information or clarify the scenario', type: 'rectangle', }, { id: 125, text: 'Prepare an example in Code Central', type: 'rectangle', }, { id: 127, text: 'Update the documentation', type: 'rectangle', }, { id: 131, text: 'Process the ticket', type: 'rectangle', }, { id: 133, text: 'Work with the R&D team', type: 'rectangle', }, ]; const flowEdges = [ { fromId: 107, id: 116, text: null, toId: 108, }, { fromId: 108, id: 117, text: null, toId: 118, }, { fromId: 118, id: 122, text: 'No', toId: 121, }, { fromId: 121, id: 123, text: null, toId: 108, }, { fromId: 131, id: 124, text: null, toId: 120, }, { fromId: 120, id: 126, text: '', toId: 125, }, { fromId: 120, id: 130, text: '', toId: 127, }, { fromId: 118, id: 132, text: 'Yes', toId: 131, }, { fromId: 131, id: 134, text: 'Need developer assistance?', toId: 133, }, { fromId: 133, id: 135, text: null, toId: 120, }, ];

Backend API
import React from 'react';
import Diagram, {
Nodes, Edges, AutoLayout, Toolbox, Group,
} from 'devextreme-react/diagram';
import { ArrayStore } from 'devextreme-react/common/data';
import service from './data.ts';
const flowNodesDataSource = new ArrayStore({
key: 'id',
data: service.getFlowNodes(),
});
const flowEdgesDataSource = new ArrayStore({
key: 'id',
data: service.getFlowEdges(),
});
export default function App() {
return (
<Diagram id="diagram">
<Nodes dataSource={flowNodesDataSource} typeExpr="type" textExpr="text">
<AutoLayout type="layered" />
</Nodes>
<Edges dataSource={flowEdgesDataSource} textExpr="text" fromExpr="fromId" toExpr="toId" />
<Toolbox>
<Group category="general" title="General" />
</Toolbox>
</Diagram>
);
}
import React from 'react';
import Diagram, {
Nodes, Edges, AutoLayout, Toolbox, Group,
} from 'devextreme-react/diagram';
import { ArrayStore } from 'devextreme-react/common/data';
import service from './data.js';
const flowNodesDataSource = new ArrayStore({
key: 'id',
data: service.getFlowNodes(),
});
const flowEdgesDataSource = new ArrayStore({
key: 'id',
data: service.getFlowEdges(),
});
export default function App() {
return (
<Diagram id="diagram">
<Nodes
dataSource={flowNodesDataSource}
typeExpr="type"
textExpr="text"
>
<AutoLayout type="layered" />
</Nodes>
<Edges
dataSource={flowEdgesDataSource}
textExpr="text"
fromExpr="fromId"
toExpr="toId"
/>
<Toolbox>
<Group
category="general"
title="General"
/>
</Toolbox>
</Diagram>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
const flowNodes = [
{
id: 107,
text: 'A new ticket',
type: 'terminator',
},
{
id: 108,
text: 'Analyze the issue',
type: 'process',
},
{
id: 118,
text: 'Do we have all information to work with?',
type: 'diamond',
},
{
id: 120,
text: 'Answered',
type: 'terminator',
},
{
id: 121,
text: 'Request additional information or clarify the scenario',
type: 'rectangle',
},
{
id: 125,
text: 'Prepare an example in Code Central',
type: 'rectangle',
},
{
id: 127,
text: 'Update the documentation',
type: 'rectangle',
},
{
id: 131,
text: 'Process the ticket',
type: 'rectangle',
},
{
id: 133,
text: 'Work with the R&D team',
type: 'rectangle',
},
];
const flowEdges = [
{
fromId: 107,
id: 116,
text: null,
toId: 108,
},
{
fromId: 108,
id: 117,
text: null,
toId: 118,
},
{
fromId: 118,
id: 122,
text: 'No',
toId: 121,
},
{
fromId: 121,
id: 123,
text: null,
toId: 108,
},
{
fromId: 131,
id: 124,
text: null,
toId: 120,
},
{
fromId: 120,
id: 126,
text: '',
toId: 125,
},
{
fromId: 120,
id: 130,
text: '',
toId: 127,
},
{
fromId: 118,
id: 132,
text: 'Yes',
toId: 131,
},
{
fromId: 131,
id: 134,
text: 'Need developer assistance?',
toId: 133,
},
{
fromId: 133,
id: 135,
text: null,
toId: 120,
},
];
export default {
getFlowNodes() {
return flowNodes;
},
getFlowEdges() {
return flowEdges;
},
};
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
const flowNodes = [
{
id: 107,
text: 'A new ticket',
type: 'terminator',
},
{
id: 108,
text: 'Analyze the issue',
type: 'process',
},
{
id: 118,
text: 'Do we have all information to work with?',
type: 'diamond',
},
{
id: 120,
text: 'Answered',
type: 'terminator',
},
{
id: 121,
text: 'Request additional information or clarify the scenario',
type: 'rectangle',
},
{
id: 125,
text: 'Prepare an example in Code Central',
type: 'rectangle',
},
{
id: 127,
text: 'Update the documentation',
type: 'rectangle',
},
{
id: 131,
text: 'Process the ticket',
type: 'rectangle',
},
{
id: 133,
text: 'Work with the R&D team',
type: 'rectangle',
},
];
const flowEdges = [
{
fromId: 107,
id: 116,
text: null,
toId: 108,
},
{
fromId: 108,
id: 117,
text: null,
toId: 118,
},
{
fromId: 118,
id: 122,
text: 'No',
toId: 121,
},
{
fromId: 121,
id: 123,
text: null,
toId: 108,
},
{
fromId: 131,
id: 124,
text: null,
toId: 120,
},
{
fromId: 120,
id: 126,
text: '',
toId: 125,
},
{
fromId: 120,
id: 130,
text: '',
toId: 127,
},
{
fromId: 118,
id: 132,
text: 'Yes',
toId: 131,
},
{
fromId: 131,
id: 134,
text: 'Need developer assistance?',
toId: 133,
},
{
fromId: 133,
id: 135,
text: null,
toId: 120,
},
];
export default {
getFlowNodes() {
return flowNodes;
},
getFlowEdges() {
return flowEdges;
},
};
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#diagram {
height: 725px;
}

Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
<template>
<DxDiagram
id="diagram"
ref="diagram"
>
<DxNodes
:data-source="flowNodesDataSource"
:text-expr="'text'"
:type-expr="'type'"
>
<DxAutoLayout :type="'layered'"/>
</DxNodes>
<DxEdges
:data-source="flowEdgesDataSource"
:text-expr="'text'"
:from-expr="'fromId'"
:to-expr="'toId'"
/>
<DxToolbox>
<DxGroup
:category="'general'"
:title="'General'"
/>
</DxToolbox>
</DxDiagram>
</template>
<script setup lang="ts">
import {
DxDiagram, DxNodes, DxAutoLayout, DxEdges, DxToolbox, DxGroup,
} from 'devextreme-vue/diagram';
import ArrayStore from 'devextreme/data/array_store';
import service from './data.ts';
const flowNodesDataSource = new ArrayStore({
key: 'id',
data: service.getFlowNodes(),
});
const flowEdgesDataSource = new ArrayStore({
key: 'id',
data: service.getFlowEdges(),
});
</script>
<style scoped>
#diagram {
height: 725px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@24.2.7/cjs',
'devextreme-vue': 'npm:devextreme-vue@24.2.7/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.16/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.60/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
const flowNodes = [
{
id: 107,
text: 'A new ticket',
type: 'terminator',
},
{
id: 108,
text: 'Analyze the issue',
type: 'process',
},
{
id: 118,
text: 'Do we have all information to work with?',
type: 'diamond',
},
{
id: 120,
text: 'Answered',
type: 'terminator',
},
{
id: 121,
text: 'Request additional information or clarify the scenario',
type: 'rectangle',
},
{
id: 125,
text: 'Prepare an example in Code Central',
type: 'rectangle',
},
{
id: 127,
text: 'Update the documentation',
type: 'rectangle',
},
{
id: 131,
text: 'Process the ticket',
type: 'rectangle',
},
{
id: 133,
text: 'Work with the R&D team',
type: 'rectangle',
},
];
const flowEdges = [
{
fromId: 107,
id: 116,
text: null,
toId: 108,
},
{
fromId: 108,
id: 117,
text: null,
toId: 118,
},
{
fromId: 118,
id: 122,
text: 'No',
toId: 121,
},
{
fromId: 121,
id: 123,
text: null,
toId: 108,
},
{
fromId: 131,
id: 124,
text: null,
toId: 120,
},
{
fromId: 120,
id: 126,
text: '',
toId: 125,
},
{
fromId: 120,
id: 130,
text: '',
toId: 127,
},
{
fromId: 118,
id: 132,
text: 'Yes',
toId: 131,
},
{
fromId: 131,
id: 134,
text: 'Need developer assistance?',
toId: 133,
},
{
fromId: 133,
id: 135,
text: null,
toId: 120,
},
];
export default {
getFlowNodes() {
return flowNodes;
},
getFlowEdges() {
return flowEdges;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.2.7/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

Node and Edge Arrays
Documentation
This demo shows the Diagram component's capability to load an external tree or a graph structure from two data sources: an array of shapes and an array of shape connectors. The connector is specified by the shape's ID attributes. The Diagram transforms information from the data sources into a tree layout view.
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
<dx-diagram #diagram id="diagram">
<dxo-nodes
[dataSource]="flowNodesDataSource"
keyExpr="id"
textExpr="text"
typeExpr="type"
>
<dxo-auto-layout type="layered"></dxo-auto-layout>
</dxo-nodes>
<dxo-edges
[dataSource]="flowEdgesDataSource"
keyExpr="id"
fromExpr="fromId"
toExpr="toId"
textExpr="text"
></dxo-edges>
<dxo-toolbox>
<dxi-group category="general" title="General"></dxi-group>
</dxo-toolbox>
</dx-diagram>
import {
NgModule, Component, ViewChild, enableProdMode,
} from '@angular/core';
import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { HttpClient, HttpClientModule } from '@angular/common/http';
import { DxDiagramModule, DxDiagramComponent } from 'devextreme-angular';
import ArrayStore from 'devextreme/data/array_store';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
preserveWhitespaces: true,
})
export class AppComponent {
flowNodesDataSource: ArrayStore;
flowEdgesDataSource: ArrayStore;
constructor(service: Service) {
this.flowNodesDataSource = new ArrayStore({
key: 'id',
data: service.getFlowNodes(),
});
this.flowEdgesDataSource = new ArrayStore({
key: 'id',
data: service.getFlowEdges(),
});
}
}
@NgModule({
imports: [
BrowserModule,
BrowserTransferStateModule,
HttpClientModule,
DxDiagramModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #diagram {
height: 725px;
}
import { Injectable } from '@angular/core';
export class FlowNode {
id: number;
text: string;
type: string;
}
export class FlowEdge {
id: number;
fromId: number;
toId: number;
text: string;
}
const flowNodes: FlowNode[] = [
{
id: 107,
text: 'A new ticket',
type: 'terminator',
},
{
id: 108,
text: 'Analyze the issue',
type: 'process',
},
{
id: 118,
text: 'Do we have all information to work with?',
type: 'diamond',
},
{
id: 120,
text: 'Answered',
type: 'terminator',
},
{
id: 121,
text: 'Request additional information or clarify the scenario',
type: 'rectangle',
},
{
id: 125,
text: 'Prepare an example in Code Central',
type: 'rectangle',
},
{
id: 127,
text: 'Update the documentation',
type: 'rectangle',
},
{
id: 131,
text: 'Process the ticket',
type: 'rectangle',
},
{
id: 133,
text: 'Work with the R&D team',
type: 'rectangle',
},
];
const flowEdges: FlowEdge[] = [
{
fromId: 107,
id: 116,
text: null,
toId: 108,
},
{
fromId: 108,
id: 117,
text: null,
toId: 118,
},
{
fromId: 118,
id: 122,
text: 'No',
toId: 121,
},
{
fromId: 121,
id: 123,
text: null,
toId: 108,
},
{
fromId: 131,
id: 124,
text: null,
toId: 120,
},
{
fromId: 120,
id: 126,
text: '',
toId: 125,
},
{
fromId: 120,
id: 130,
text: '',
toId: 127,
},
{
fromId: 118,
id: 132,
text: 'Yes',
toId: 131,
},
{
fromId: 131,
id: 134,
text: 'Need developer assistance?',
toId: 133,
},
{
fromId: 133,
id: 135,
text: null,
toId: 120,
},
];
@Injectable()
export class Service {
getFlowNodes() {
return flowNodes;
}
getFlowEdges() {
return flowEdges;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.17',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17',
'@angular/forms': 'npm:@angular/forms@12.2.17',
'@angular/common': 'npm:@angular/common@12.2.17',
'@angular/compiler': 'npm:@angular/compiler@12.2.17',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@23.1.6/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49',
'devextreme-angular': 'npm:devextreme-angular@23.1.6',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.17/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@23.1.6/*/package.json',
'npm:devextreme-angular@23.1.6/ui/*/package.json',
'npm:devextreme-angular@23.1.6/package.json',
'npm:devexpress-diagram@2.2.2/package.json',
'npm:devexpress-gantt@4.1.49/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx-diagram.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>